# Capítlulo 9: Introducción a los Scripts de Bitcoin

Hasta la fecha, hemos estado interactuando con Bitcoin a un nivel relativamente alto de abstracción. El programa `bitcoin-cli` ofrece acceso a una variedad de comandos RPC que respaldan la creación y el control de transacciones de Bitcoin sin procesar que incluyen fondos, datos, temporizadores y multifirmas.

Sin embargo, Bitcoin ofrece mucha más complejidad que eso. Incluye un lenguaje de programación simple que se puede utilizar para crear condiciones de canje aún más complejas. Si las multifirmas y los bloqueos temporales proporcionaron las bases de los contratos inteligentes, entonces Bitcoin Script construye encima de esa base. Es el siguiente paso para empoderar a Bitcoin.

## Objetivos de Este Capítulo

Después de trabajar en este capítulo, un desarrollador podrá:

   * Diseñar un script de Bitcoin
   * Aplicar un script de Bitcoin
   
Los objetivos de apoyo incluyen la capacidad de:

   * Comprender el propósito de los scripts de Bitcoins
   * Comprender el script P2PKH
   * Comprender cómo funciona P2WPKH con scripts Bitcoin
   * Comprenda las necesidades de las pruebas de scripts de Bitcoin
   
## Tabla de Contenido

* [Sección Uno: Comprensión de la Base de las Transacciones](09_1_Understanding_the_Foundation_of_Transactions.md)
* [Sección Dos: Ejecución de un Script de Bitcoin](09_2_Running_a_Bitcoin_Script.md)
* [Sección Tres: Generar Scripts de P2PKH](09_3_Scripting_a_P2PKH.md)
* [Sección Cuatro: Pueba de un Script de Bitcoin](09_4_Testing_a_Bitcoin_Script.md)
* [Sección Cinco: Generar Scripts de P2WPKH](09_5_Scripting_a_P2WPKH.md)
